package com.hepia.backend.controller;

import com.hepia.backend.model.dto.CreateTodoRequest;
import com.hepia.backend.model.entity.Todo;
import com.hepia.backend.repository.TodoRepository;
import com.hepia.backend.service.TodoService;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static org.springframework.http.HttpStatus.CREATED;

@RestController
@RequestMapping("/todos")
@RequiredArgsConstructor
public class TodoController {
    private final TodoService todoService;

    @GetMapping
    public ResponseEntity<List<Todo>> getAll() {
        return todoService.getAll();
    }

    @PostMapping
    public ResponseEntity<Todo> create(@RequestBody CreateTodoRequest request) {
        return todoService.create(request);
    }

    @DeleteMapping("/{id}")
    public ResponseEntity<Long> delete(@PathVariable Long id) {
        return todoService.delete(id);
    }

    @PatchMapping("/{id}")
    public ResponseEntity<Todo> toggleCompleted(@PathVariable Long id) {
        return todoService.toggleCompleted(id);
    }
}
