import { TodoService } from '@core/ports/todo.service';
import { inject } from '@angular/core';
import { HttpService } from '@shared/http.service';
import { Todo, Todos } from '@core/models/todo';
import { Observable } from 'rxjs';

export class HttpTodoService implements TodoService {
  private readonly http = inject(HttpService);

  getAll(): Observable<Todos> {
    return this.http.get<Todos>('todos');
  }

  add(todoName: string): Observable<Todo> {
    return this.http.post<Todo>('todos', { name: todoName });
  }

  toggleCompleted(todoId: number): Observable<Todo> {
    return this.http.patch<Todo>(`todos/${todoId}`, {});
  }

  remove(todoId: number): Observable<number> {
    return this.http.delete<number>(`todos/${todoId}`);
  }
}
