import { Todo } from '@core/models/todo';

export class TodoBuilder {
  protected id!: number;
  protected name!: string;
  protected completed!: boolean;

  withId(id: number): this {
    this.id = id;
    return this;
  }

  withName(name: string): this {
    this.name = name;
    return this;
  }

  complete(): this {
    this.completed = true;
    return this;
  }

  uncomplete(): this {
    this.completed = false;
    return this;
  }

  build(): Todo {
    return {
      id: this.id,
      name: this.name,
      completed: this.completed,
    };
  }
}
