import { Component, output } from '@angular/core';
import { FormsModule } from '@angular/forms';

@Component({
  selector: 'app-add-todo-form',
  template: `
    <form (ngSubmit)="this.add.emit(todoInput.value); todoInput.value = ''">
      <div class="flex space-x-2">
        <input
          #todoInput
          class="input input-xl input-bordered w-full"
          name="add todo"
          placeholder="Ex : Aller se promener"
          type="text"
        />
        <button class="btn btn-neutral btn-xl" type="submit">Ajouter</button>
      </div>
    </form>
  `,
  imports: [FormsModule],
})
export class AddTodoFormComponent {
  add = output<string>();
}
