import { Component, HostListener, output, signal } from '@angular/core';

@Component({
  selector: 'app-modal-confirm',
  template: `
    @if (isOpen()) {
      <dialog id="modal" class="modal modal-open modal-bottom sm:modal-middle">
        <div class="modal-box">
          <h3 class="font-bold text-lg">Confirmation</h3>
          <p class="py-4">Êtes-vous sûr de vouloir supprimer cette tâche ?</p>
          <div class="modal-action">
            <form method="dialog">
              <button class="btn btn-outline mr-2" (click)="close()">Annuler</button>
              <button class="btn btn-error" (click)="confirm.emit(); this.close()">Supprimer</button>
            </form>
          </div>
        </div>
      </dialog>
    }
  `,
})
export class ModalConfirmComponent {
  isOpen = signal(false);
  confirm = output<void>();

  open = () => this.isOpen.set(true);

  @HostListener('document:keydown.escape')
  close = () => this.isOpen.set(false);
}
