import { inject, Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { environment } from '@env/environment';

@Injectable({
  providedIn: 'root',
})
export class HttpService {
  private readonly http = inject(HttpClient);
  private readonly url = environment.api.url;

  get<T>(endpoint: string) {
    return this.http.get<T>(`${this.url}/${endpoint}`);
  }

  post<T>(endpoint: string, body: any) {
    return this.http.post<T>(`${this.url}/${endpoint}`, body);
  }

  patch<T>(endpoint: string, body: any) {
    return this.http.patch<T>(`${this.url}/${endpoint}`, body);
  }

  delete<T>(endpoint: string) {
    return this.http.delete<T>(`${this.url}/${endpoint}`);
  }
}
